// Fig. 7.4: Test.java
// Casting superclass references to subclass references
import java.text.DecimalFormat;
import java.io.*;

public class Test  {

   public static void main(String[] args) throws java.io.IOException
   {  // can't instantiate an object of an abstract class
      Point pointRef, circleRef, cylRef;//  p=new Point(30,50);
      Circle c=new Circle(1.5,4,10);
      Cylinder cyl=new Cylinder(5,5,10,5,12);

      DecimalFormat precision2 = new DecimalFormat( "#.00" );

      System.out.println( "Circle c: " + c +
                                  " Area: "+ precision2.format(c.area()));
      System.out.println("Cylinder cyl: "+cyl+
            " Surface Area: "+precision2.format(cyl.area())
                                +" Volume: "+precision2.format(cyl.volume()));

      // Attempt to treat a Circle as a Point
      pointRef = c;   // assign Circle to pointRef
      System.out.println( "Circle c (via pointRef): " +pointRef +
                                " Area: "+ precision2.format(pointRef.area()));

      // Attempt to treat a Cylinder as a Point
      pointRef = (Cylinder)cyl;   // assign Cylinder to pointRef
      System.out.println( "Cylinder cyl (via pointRef): " +pointRef+
                          " Surface Area: "+ precision2.format(pointRef.area()) +
                                    " Volume: "+precision2.format(pointRef.volume()));

      // Treat a Circle as a Circle (with some casting)
      pointRef=c;
      Circle cRef = (Circle) pointRef;  // cast super to sub
      System.out.println( "Circle c (via cRef): " +cRef);
      System.out.println( " Area of c (via cRef): " +
                                     precision2.format(cRef.area()));

      // Attempt to refer to Circle object
      // with Cylinder reference
      Cylinder cylinderRef;
      try {
          cylinderRef = (Cylinder) c;    // line 39 in Test.java
      }
      catch (Exception e) {
            System.out.println("Circle via Cylinder Reference Crashed");
      }

      System.out.println("END");
   }
}
